﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

End Sub

Sub Globals
	Private spnFirstName, spnLastName, spnCity As Spinner
	Private btnFilter, btnBooleanOperator As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Filter")
	Activity.Title = "Filter "
	InitSpinners
End Sub

Sub Activity_Resume
	'set the text of the btnBooleanOperator button
	btnBooleanOperator.Text = Starter.FilterBooleanOperator

	'set the last selected indexes of the Spinners
	spnFirstName.SelectedIndex = Starter.SelectedFirstName
	spnLastName.SelectedIndex = Starter.SelectedLastName
	spnCity.SelectedIndex = Starter.SelectedCity
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub btnFilter_Click
	Starter.FilterQuery = GetFilterQuery

	'set the filter to active
	Starter.flagFilterActive = True
	
	'memorize the selected indexes of the Spinners
	Starter.SelectedFirstName = spnFirstName.SelectedIndex
	Starter.SelectedLastName = spnLastName.SelectedIndex
	Starter.SelectedCity = spnCity.SelectedIndex
	
	'quit the Activity, returns to the DBWebView Activity
	Activity.Finish
End Sub

Sub GetFilterQuery As String
	'a query will look like something
	' WHERE FirstName = 'John'
	' WHERE FirstName = 'John' AND LastName = 'KENNEDY'
	' WHERE FirstName = 'John' AND City = 'London'
	' WHERE FirstName = 'John' AND LastName = 'KENNEDY' AND City = 'London'
	'the single quotes are needed because the values are strings
	
	Private Query1 = " WHERE " As String	'beginning of the query1
	
	'if a FirstName is selected then spnFirstName.SelectedIndex > 0 and we add FirstName = 'selected first name'
	If spnFirstName.SelectedIndex > 0 Then
		Query1 = Query1 & "Names = '" & spnFirstName.SelectedItem & "' "
	End If

	'if a LastName is selected then we add
	' LastName = 'selected last name' if no first name was selected
	' AND LastName = 'selected last name' or OR LastName = 'selected last name'
	'depending on the boolean operator
	If spnLastName.SelectedIndex > 0 Then
		If Query1 = " WHERE " Then
			Query1 = Query1 & "Class = '" & spnLastName.SelectedItem & "' "
		Else
			Query1 = Query1 & Starter.FilterBooleanOperator & "Class = '" & spnLastName.SelectedItem & "' "
		End If
	End If

	'if a City is selected then we add
	' City = 'selected city' if it's the first selection
	' AND City = 'selected city' or OR City = 'selected city'
	'depending on the boolean operator
	If spnCity.SelectedIndex > 0 Then
		If Query1 = " WHERE " Then
			Query1 = Query1 & "Stream = '" & spnCity.SelectedItem & "' "
		Else
			Query1 = Query1 & Starter.FilterBooleanOperator & "Stream = '" & spnCity.SelectedItem & "' "
		End If
	End If
	
	'if nothing was selected set Query = ""
	If Query1 = " WHERE " Then
		Query1 = ""
	End If
	
	Return Query1
End Sub

Sub btnBooleanOperator_Click
	'selects the boolean operator and changes the text in the button
	If btnBooleanOperator.Text = "OR " Then
		btnBooleanOperator.Text = "AND "
		Starter.FilterBooleanOperator = "AND "
	Else
		btnBooleanOperator.Text = "OR "
		Starter.FilterBooleanOperator = "OR "
	End If
End Sub


'Initialize the Spinners
Sub InitSpinners
	Private i As Int
	Private Query1 As String
	Private Curs As Cursor
	
	'We execute a query for each column and fill the Spinner
	'We use SELECT DISTINCT to have each existing first name in the database only once
'	Query1 = "SELECT DISTINCT FirstName FROM persons"
	Query1 = "SELECT DISTINCT Names FROM Balances ORDER BY Names ASC"
	Curs = Starter.SQL1.ExecQuery(Query1)
	'we add 'no filter' as no selection
	spnFirstName.Add("no filter")
	'we fill the Spinner with the data from the database
	For i = 0 To Curs.RowCount - 1
		Curs.Position = i
		spnFirstName.Add(Curs.GetString("Names"))
	Next
	
	'same for last name
'	Query1 = "SELECT DISTINCT LastName FROM persons"
	Query1 = "SELECT DISTINCT Class FROM Balances ORDER BY Names ASC"
	Curs = Starter.SQL1.ExecQuery(Query1)
	spnLastName.Add("no filter")
	For i = 0 To Curs.RowCount - 1
		Curs.Position = i
		spnLastName.Add(Curs.GetString("Class"))
	Next
	
	'same for city
'	Query1 = "SELECT DISTINCT City FROM persons"
	Query1 = "SELECT DISTINCT Stream FROM Balances ORDER BY Names ASC"
	Curs = Starter.SQL1.ExecQuery(Query1)
	spnCity.Add("no filter")
	For i = 0 To Curs.RowCount - 1
		Curs.Position = i
		spnCity.Add(Curs.GetString("Stream"))
	Next
	Curs.Close
	
End Sub


Sub btnEdit_Click
	'Activity.RemoveAllViews
	'Activity.LoadLayout("1")
	'Activity.star
	'StartActivity(Starter)
End Sub